"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var WaveVisualView = react_native_1.requireNativeComponent("OGWave");
var WaveVisual = (function (_super) {
    __extends(WaveVisual, _super);
    function WaveVisual(props) {
        var _this = _super.call(this, props) || this;
        _this.makeId = function () {
            var text = "";
            var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
            for (var i = 0; i < 5; i++)
                text += possible.charAt(Math.floor(Math.random() * possible.length));
            return text;
        };
        _this.onPress = function (e) {
            var event = react_native_1.Platform.OS === "ios" ? e.nativeEvent : e;
            if (event.componentID === _this.state.componentId && _this.props.onPress) {
                _this.props.onPress(event);
            }
        };
        _this.onFinishPlay = function (e) {
            var event = react_native_1.Platform.OS === "ios" ? e.nativeEvent : e;
            if (event.componentID === _this.state.componentId &&
                _this.props.onFinishPlay) {
                _this.props.onFinishPlay(event);
            }
        };
        _this.state = {
            componentId: ""
        };
        react_native_1.DeviceEventEmitter.addListener("OGOnPress", _this.onPress);
        react_native_1.DeviceEventEmitter.addListener("OGFinishPlay", _this.onFinishPlay);
        return _this;
    }
    WaveVisual.prototype.componentDidMount = function () {
        var componentId = this.makeId();
        this.setState({ componentId: componentId });
    };
    WaveVisual.prototype.render = function () {
        var _a = this.props, _b = _a.source, source = _b === void 0 ? {} : _b, waveFormStyle = _a.waveFormStyle;
        var componentId = this.state.componentId;
        var assetResoved = react_native_1.Image.resolveAssetSource(source) || {};
        var uri = assetResoved.uri;
        if (uri && uri.match(/^\//)) {
            uri = "file://" + uri;
        }
        var isNetwork = !!(uri && uri.match(/^https?:/));
        var isAsset = !!(uri && uri.match(/^(assets-library|file|content|ms-appx|ms-appdata):/));
        var nativeProps = __assign(__assign({}, this.props), { waveFormStyle: {
                ogWaveColor: react_native_1.processColor(waveFormStyle.waveColor),
                ogScrubColor: react_native_1.processColor(waveFormStyle.scrubColor)
            }, src: {
                uri: uri,
                isNetwork: isNetwork,
                isAsset: isAsset,
                type: source.type,
                mainVer: source.mainVer || 0,
                patchVer: source.patchVer || 0
            }, componentID: componentId });
        return (<WaveVisualView {...nativeProps} onPress={this.onPress} onFinishPlay={this.onFinishPlay}/>);
    };
    return WaveVisual;
}(React.PureComponent));
exports.default = WaveVisual;
//# sourceMappingURL=index.js.map